﻿package 
{
	import com.bit101.components.CheckBox;
	import com.bit101.components.HUISlider;
	import com.bit101.components.PushButton;
	import com.bit101.components.RadioButton;
	
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import net.nicoptere.geometry.NaturalCubic;
	import flash.geom.Point;
	import flash.utils.getDefinitionByName;
	/**
	 * @author nicoptere
	 * 
	 * pics from
	 * http://www.room122.com/freebies/free-illustrator-art-brushes/
	 * and
	 * http://www.bittbox.com/freebies/random-free-vectors-part-11-watercolors
	 */
	public class Main extends Sprite 
	{
		
		[Embed(source = '../lib/pattern_0.png')]private var pattern_0:Class;
		[Embed(source = '../lib/pattern_1.png')]private var pattern_1:Class;
		[Embed(source = '../lib/pattern_2.png')]private var pattern_2:Class;
		[Embed(source = '../lib/pattern_3.png')]private var pattern_3:Class;
		[Embed(source = '../lib/pattern_4.png')]private var pattern_4:Class;
		[Embed(source = '../lib/pattern_5.png')]private var pattern_5:Class;
		
		
		private var strokes:Vector.<RichStroke>;
		private var rs:RichStroke;
		private var nc:NaturalCubic;
		private var points:Vector.<Point>;
		
		private var src:BitmapData;
		private var drag:Boolean = false;
		
		//interface
		private var animate:CheckBox;
		private var constant:CheckBox;
		private var debug:CheckBox;
		private var smoothrender:CheckBox;
		private var steps:HUISlider;
		private var reset:PushButton;
		
		private var pattern:Bitmap = new Bitmap();
		private var debugCanvas:Shape = new Shape();
		private var interfaceBG:Sprite = new Sprite();
		
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			
			removeEventListener(Event.ADDED_TO_STAGE, init);
			stage.scaleMode = 'noScale';
			
			points = new Vector.<Point>( );
			
			nc = new NaturalCubic();
			
			strokes = new Vector.<RichStroke>();
			
			/**********************************************************/
			interfaceBG.graphics.beginFill( 0xDDDDDD );
			interfaceBG.graphics.drawRect( 0, 500, 500, 100 );
			addChild( interfaceBG );
			
			reset = new PushButton( this, 10, 510, 'reset', resetHandler );
			
			debug = new CheckBox( this, 10, 540, 'show debug', debugHandler );
			constant = new CheckBox( this, 100, 540, 'constant' );
			animate = new CheckBox( this, 10, 556, 'animate map' );
			smoothrender = new CheckBox( this, 100, 556, 'smooth bitmap' );
			animate.selected = debug.selected = constant.selected = false;
			
			debugHandler( null );
			
			steps = new HUISlider( this, 10, 568, 'smooth curve' );
			steps.minimum = 1;
			steps.value = 3;
			steps.maximum = 10;
			
			var i:int = 6;
			while( i-- )
			{
				var rb:RadioButton = new RadioButton( this ,  130 + ( i * 60 ), 516,'brush '+i, false, getBitmap );
			}
			rb.selected = true;
			
			/**********************************************************/
			
			debugCanvas.blendMode = BlendMode.LAYER;
			addChild( debugCanvas );
			
			addChild( pattern );
			pattern.bitmapData = src =  Bitmap( new pattern_0() ).bitmapData;
			pattern.smoothing = true;
			pattern.x = pattern.width = 220;
			pattern.y = 570 - pattern.height / 2;
			
			/**********************************************************/
			
			stage.addEventListener( MouseEvent.MOUSE_DOWN, mouse );
			stage.addEventListener( MouseEvent.MOUSE_UP, mouse );
			addEventListener( Event.ENTER_FRAME, oef );
			
		}
		
		
		private function getBitmap( e:Event = null ):void
		{
			var img:Class = pattern_0;
			if ( e != null )
			{
				var rb:RadioButton = ( e.currentTarget as RadioButton );
				switch( parseInt( rb.label.substr( rb.label.length - 1 ) ) )
				{
					case 0 : img = pattern_0; break;
					case 1 : img = pattern_1; break;
					case 2 : img = pattern_2; break;
					case 3 : img = pattern_3; break;
					case 4 : img = pattern_4; break;
					case 5 : img = pattern_5; break;
				}
			}
			pattern.bitmapData = src =  Bitmap( new img() ).bitmapData;
			pattern.scaleX = pattern.scaleY = 250 / src.width;
			pattern.y = 570 - pattern.height / 2;
			
		}
		
		private function debugHandler( e:Event ):void
		{
			debugCanvas.visible = debug.selected;
		}
		
		private function resetHandler( e:Event ):void
		{
			
			for each( var s:RichStroke in strokes )
			{
				s.dispose();
			}
			debugCanvas.graphics.clear();
			strokes = new Vector.<RichStroke>();
			
		}
		private function mouse( e:MouseEvent ):void
		{
			steps.value = int( steps.value + .5 );
			if ( e.type == 'mouseDown' && mouseY < 500 )
			{
				drag = true;
				this.graphics.lineStyle(0 );
				this.graphics.moveTo( mouseX, mouseY );
				
			}
			
			if ( e.type == 'mouseUp' && mouseY < 500 )
			{
				
				if ( points.length == 0 ) return;
				
				nc.closed = false;
				nc.steps = int( steps.value );
				nc.controlPoints = Utils.simplifyLang( 20, 2, points );
				
				
				rs = new AnimatedStroke( src );
				rs.debug = 1;
				var quads:Vector.<Quad> = rs.fromCurve( nc.curveAsPoints, constant.selected , debugCanvas.graphics )
				rs.debug = 1;
				
				
				drag = false;
				points = new Vector.<Point>();
				strokes.push( rs );
				rs.setQuads( quads );
				debugCanvas.cacheAsBitmap = true;
			}
		}
		
		private function oef( e:Event ):void
		{
			if ( drag )
			{
				points.push( new Point( mouseX, mouseY ) );
				this.graphics.lineTo( mouseX, mouseY);
			}
			else 
			{
				this.graphics.clear();
				for each( var s:RichStroke in strokes )
				{
					s.draw( this.graphics, smoothrender.selected );
					if( animate.selected && ( s is AnimatedStroke )) ( s as AnimatedStroke ).animate();
				}
			}
			
		}
	}
}